/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.wahlausschuss;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.wahlausschuss.boundary.AbstractWahlausschussmitgliedSearchParameters;
import de.ivu.elect.business.wahlausschuss.boundary.WahlausschussmitgliedChangeEvent;
import de.ivu.elect.business.wahlausschuss.boundary.WahlausschussmitgliedConversationStore;
import de.ivu.elect.business.wahlausschuss.boundary.WahlausschussmitgliedExtendedDAO;
import de.ivu.elect.business.wahlausschuss.boundary.WahlausschussmitgliedSearch;
import de.ivu.elect.business.wahlausschuss.boundary.WahlausschussmitgliedSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.wahlausschuss.entity.Wahlausschussmitglied;
import de.ivu.elect.business.wahlausschuss.entity.WahlausschussmitgliedMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractWahlausschussmitgliedSearchView.COMPONENT_NAME)
@View(viewId = AbstractWahlausschussmitgliedSearchView.VIEW_ID, useCase = UseCasePermission.WAHLAUSSCHUSSMITGLIED_SEARCH)
public abstract class AbstractWahlausschussmitgliedSearchView extends AbstractElectSearchView<Wahlausschussmitglied> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wahlausschussmitgliedSearchView";
  
  public static final String VIEW_ID = "/wahlausschuss/wahlausschussmitglied-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractWahlausschussmitgliedSearchView requestHandler;

  @Inject
  private transient WahlausschussmitgliedExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(WahlausschussmitgliedConversationStore.class)
  protected transient WahlausschussmitgliedConversationStore conversationStore;

  @Inject
  protected transient WahlausschussmitgliedSearch search;

  @Inject
  @ConversationGroup(AbstractWahlausschussmitgliedSearchParameters.class)
  protected transient WahlausschussmitgliedSearchParameters searchParameters;

  @Inject
  protected transient WahlausschussmitgliedMeta entityMeta;

  public AbstractWahlausschussmitgliedSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Wahlausschussmitglied getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Wahlausschussmitglied entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public WahlausschussmitgliedSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Wahlausschussmitglied> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Wahlausschussmitglied> create();
  }

  @Override
  public List<Wahlausschussmitglied> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Wahlausschussmitglied> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onWahlausschussmitgliedChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlausschussmitgliedChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //   Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractWahlausschussmitgliedSearchView {

    @View
    @Inject
    private transient Instance<AbstractWahlausschussmitgliedSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractWahlausschussmitgliedSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
